      SUBROUTINE EXT_PAOBREU(KNBMESS,KNBMECR,CDTYPM,KNBWAG,
     &                       PLATN,PLATS,PLONO,PLONE,KPLEIN)
!-----------------------------------------------------------------------
!  auteur de revision : F. Guillaume
!  date de revision   : 17/03/2008
!  objet              : formats explicites d'ecriture dans OBSOUL
!                       pour mise en conofmite SOPRANO.
!=======================================================================
      IMPLICIT LOGICAL(L)

#include "oulan_pardimo.h"
#include "oulan_yomtomv.h"
#include "oulan_yompin.h"
#include "oulan_yomdirs.h"
#include "oulan_yomnbob.h"
#include "oulan_yomdate.h"
#include "oulan_yomcsts.h"

      PARAMETER ( JP_NBX_PAR = 71        , JP_LN_STRUCT = 100          )

      CHARACTER  CLLAT            *  12 , CLLON                    *  12
      CHARACTER  CDTYPM           *  10 , CL_NULL                 *    5

      CHARACTER  CL_TYPE_MESS     *  20 , CL_VERS_MESS             *  20
      CHARACTER  CL_MIN_DATE      *  14 , CL_MAX_DATE              *  14
      CHARACTER  CL_LAST_ARRIVED  *   1 , CL_LISTE_PARAM(1)        *  15
      CHARACTER  CL_LISTE_STAT(1) *   4 , CL_DONNEES(5,KNBMESS)    *  80
      CHARACTER  CL_AUTORISATION  *  30
      INTEGER    I_PAS_DE_TPS , I_NB_PARAM , I_TYPE_SORTIE , I_NBRE_STAT
      INTEGER    I_CODE_RETOUR_EXT , I_NB_MESS, INBSEUIL
      REAL       Z_DONNEES(JP_LN_STRUCT,KNBMESS)

      REAL  DL_MIN_LAT , DL_MAX_LAT
      REAL  DL_MIN_LON , DL_MAX_LON

      CHARACTER  CLINDIC          * 12
      CHARACTER  CLINDICAB        * 12
      INTEGER    IVNM(JP_NBX_PAR),IFLG(JP_NBX_PAR)
      REAL       ZPOB(JP_NBX_PAR),ZPRL(JP_NBX_PAR),ZVAR(JP_NBX_PAR)

! ----------------------------------------------------------------------
! code pour realiser des sorties formatees  OBSOUL (SOPRANO)

      character entete * 84, wagon_prov * 34
      character wagon  * 34, fmt_final * 117
! ----------------------------------------------------------------------


#include "oulan_yombitu.h"

! ----------------------------------------------------------------------
! code pour realiser des sorties formatees  OBSOUL (SOPRANO)

      entete = "(A12,1X,A12,1X,I9,1X,I8,1X,I6,1X,A12,1X,A12,1X,I6,1X"
      wagon_prov = "(I5,'(1X,ES12.5)')"                       
! ----------------------------------------------------------------------

      KNBMECR = 0
      KPLEIN  = 0

      CL_NULL  = 'NULL'//CHAR(0)

      IZERO    = 0
      ICQUN    = 1
!-----------------------------------------------------------------------

!  Initialisations des arguments de la fonction d'extraction
!  ---------------------------------------------------------

      CL_TYPE_MESS( 1:10) = CDTYPM
      CL_TYPE_MESS(11:20) = '          '
      CL_VERS_MESS        = '%                   '
      CL_MIN_DATE         = CDATDEB(2)
      CL_MAX_DATE         = CDATFIN(2)
      CL_AUTORISATION     = 'OPER                          '
      CL_LAST_ARRIVED     = 'Y'
      CL_LISTE_STAT(1)    = 'NULL'
      CL_LISTE_PARAM(1)   = 'NULL           '

      I_PAS_DE_TPS      = 0
      I_NB_PARAM        = 0
      I_TYPE_SORTIE     = 3
      I_NBRE_STAT       = 0
      I_NB_MESS         = KNBMESS

      DL_MIN_LAT        = PLATS
      DL_MAX_LAT        = PLATN
      DL_MIN_LON        = PLONO
      DL_MAX_LON        = PLONE

      CL_DONNEES          = ' '
      Z_DONNEES           = RABSI

!-----------------------------------------------------------------------

!  Extraction
!  ----------

      PRINT *,' '
      PRINT *,' Extraction des PAOB REUNION'
      PRINT *,' '

      CALL RDLLTDOMAINDECOD( CL_TYPE_MESS , CL_VERS_MESS , CL_MIN_DATE ,
     &                       CL_MAX_DATE , CL_AUTORISATION ,
     &                       CL_LAST_ARRIVED , I_PAS_DE_TPS ,
     &                       CL_NULL , I_NB_PARAM , Z_DONNEES ,
     &                       CL_DONNEES , CL_NULL , I_TYPE_SORTIE ,
     &                       I_NB_MESS , DL_MIN_LAT , DL_MAX_LAT ,
     &                       DL_MIN_LON , DL_MAX_LON , CL_NULL ,
     &                       I_NBRE_STAT , I_CODE_RETOUR_EXT )

      PRINT *,' '
      PRINT *,' Fin de l''extraction '
      PRINT *,' '

      IF ( I_CODE_RETOUR_EXT.NE.0 .AND.
     &     I_CODE_RETOUR_EXT.NE.1       ) THEN
        PRINT 101,CDTYPM,I_CODE_RETOUR_EXT
 101    FORMAT(/,' Probleme lors de l''extraction des ',A10,
     &         ' I_CODE_RETOUR_EXT = ',I2,/)
        RETURN
      ENDIF

      IF ( I_NB_MESS.EQ.KNBMESS ) KPLEIN = I_NB_MESS

      IF ( NINIT.EQ.1 ) RETURN

!-----------------------------------------------------------------------

!  Traitements
!  -----------

      I_NB_CRC   = 0
      I_NB_JAP   = 0
      I_NB_USA   = 0
      I_NB_AUS   = 0
      I_NB_FID   = 0
      I_NB_AUT   = 0
      I_NB_CRC_P = 0
      I_NB_JAP_P = 0
      I_NB_USA_P = 0
      I_NB_AUS_P = 0
      I_NB_FID_P = 0
      I_NB_AUT_P = 0

      OBS_BCLE: DO JO=1,I_NB_MESS
        IF ( LCUTOFF .AND. 
     &       CL_DONNEES(1,JO)(1:14).GT.CDATFIN(4) ) CYCLE OBS_BCLE
        IF ( (Z_DONNEES(23,JO).EQ.RABSI) .AND.
     &       (Z_DONNEES(41,JO).EQ.RABSI)
     &     ) CYCLE OBS_BCLE
        ICODPRO = NINT(Z_DONNEES(1,JO))
        IF ( ICODPRO.EQ.25 ) THEN
          I_NB_CRC = I_NB_CRC + 1
        ELSE IF ( ICODPRO.EQ.34 ) THEN
          I_NB_JAP = I_NB_JAP + 1
        ELSE IF ( ICODPRO.EQ.52 ) THEN
          I_NB_USA = I_NB_USA + 1
        ELSE IF ( ICODPRO.EQ.65 ) THEN
          I_NB_AUS = I_NB_AUS + 1
        ELSE IF ( ICODPRO.EQ.71 ) THEN
          I_NB_FID = I_NB_FID + 1
        ELSE
          I_NB_AUT = I_NB_AUT + 1
        ENDIF

        IRLN    = NABSO
        IOTP    = NABSO
        IOCH    = NABSO
        ZLAT    = RABSO
        ZLON    = RABSO
        IDAT    = NABSO
        IETM    = NABSO
        ZALT    = RABSO
        INLV    = NABSO
        IRFL    = 11111
        ISTD    = 0
        CLINDIC = " '        ' "
        CLINDICAB = " '        ' "
        CLLAT   = "            "
        CLLON   = "            "
        ICQLAT  = 1
        ICQLON  = 1
        ICQDAT  = 1
        ICQETM  = 1
        ICQALT  = 1

        DO JA=1,JP_NBX_PAR
          IVNM(JA) = NABSO
          ZPOB(JA) = RABSO
          ZPRL(JA) = RABSO
          ZVAR(JA) = RABSO
          IFLG(JA) = NABSO
        ENDDO

!  Saisie de la locomotive

        IOTP = NPAOB
        IOCH = NTYPHO
        ZLAT = Z_DONNEES(14,JO)
        ZLON = Z_DONNEES(15,JO)
        WRITE (CLLAT(2:11),'(F10.5)') ZLAT
        WRITE (CLLON(2:11),'(F10.5)') ZLON
        IOCH    = NTYPHO
!        CALL OULAN_CAROBS(IOTP,CDTYPM,ICODPRO,IZERO,IZERO,ZLAT,IOCH)
        IDAT = NINT( Z_DONNEES( 9,JO) ) * 10000  +
     &         NINT( Z_DONNEES(10,JO) ) * 100    +
     &         NINT( Z_DONNEES(11,JO) )
        IETM = NINT( Z_DONNEES(12,JO) ) * 10000  +
     &         NINT( Z_DONNEES(13,JO) ) * 100

!  identifiant cyclone

        IVALCL = NINT( Z_DONNEES(8,JO) )
        INOCL  = IVALCL / 1000
        ILNCL  = MOD( IVALCL , 1000 )
        IF ( INOCL.GE.1 .AND. INOCL.LE.5 ) THEN
          IF ( ILNCL.GE.8 ) THEN
            CLINDIC(3:10) = CL_DONNEES(INOCL,JO)(1:8)
          ELSE
            CLINDIC(3:2+ILNCL) = CL_DONNEES(INOCL,JO)(1:ILNCL)
          ENDIF
        ENDIF

!  identifiant abrege cyclone

        IVALCL = NINT( Z_DONNEES(7,JO) )
        INOCL  = IVALCL / 1000
        ILNCL  = MOD( IVALCL , 1000 )
        IF ( INOCL.GE.1 .AND. INOCL.LE.5 ) THEN
          IF ( ILNCL.GE.8 ) THEN
            CLINDICAB(3:10) = CL_DONNEES(INOCL,JO)(1:8)
          ELSE
            CLINDICAB(3:2+ILNCL) = CL_DONNEES(INOCL,JO)(1:ILNCL)
          ENDIF
        ENDIF

!        IRFL = ICQALT*10000 + ICQETM*1000 + ICQDAT*100 + ICQLON*10 +
!     &         ICQLAT

        IF ( Z_DONNEES(5,JO).NE.RABSI )
     &    ISTD = INT(Z_DONNEES(5,JO)+REPSILON)

!  Saisie des wagons

!  composition du code qualite (IFLG) :

!     bits 1 et 2   code qualite coordonnee verticale
!     bits 3 et 4   code qualite parametre mesure
!     bit    12     coordonnee verticale en Pascals
!     bit    13     coordonnee verticale en metres

        INBP = 0

!  indentifiant terre mer

        INBP = INBP + 1
        IF ( Z_DONNEES(16,JO).NE.RABSI) THEN
          ZPOB(INBP) = Z_DONNEES(16,JO)
        ENDIF

!  sens deplacement

        INBP = INBP + 1
        IF ( Z_DONNEES(19,JO).NE.RABSI) THEN
          ZPOB(INBP) = Z_DONNEES(19,JO)
        ENDIF

!  vitesse deplacement

        INBP = INBP + 1
        IF ( Z_DONNEES(20,JO).NE.RABSI) THEN
          ZPOB(INBP) = Z_DONNEES(20,JO)
        ENDIF

!  Pmer au centre du cyclone (via geopotentiel)

        INBP = INBP + 1
        IF ( Z_DONNEES(23,JO).NE.RABSI) THEN
          ZPOB(INBP) = Z_DONNEES(23,JO)
        ENDIF

!  vitesse max du vent moyen

        INBP = INBP + 1
        IF ( Z_DONNEES(29,JO).NE.RABSI) THEN
          ZPOB(INBP) = Z_DONNEES(29,JO)
        ENDIF

!  rayon

        INBP = INBP + 1
        IF ( Z_DONNEES(30,JO).NE.RABSI) THEN
          ZPOB(INBP) = Z_DONNEES(30,JO)
        ENDIF

!  nombre de seuils et donnees quadrants

        ID = 32
        INBP = INBP + 1
        IF ( Z_DONNEES(32,JO).NE.RABSI) THEN
          ZPOB(INBP) = NINT(Z_DONNEES(32,JO))
	  INBSEUIL = NINT(Z_DONNEES(32,JO))
	  DO JS = 1,INBSEUIL
	    DO JQ = 1,16
	      ID = ID + 1
	      INBP = INBP + 1
              IF ( Z_DONNEES(ID,JO).NE.RABSI) THEN
	        ZPOB(INBP) = Z_DONNEES(ID,JO)
              ENDIF
	    ENDDO
	  ENDDO
        ENDIF

!  Copie de l'observation sur le fichier d'obs.

        IF ( INBP.GT.0 ) THEN
          ILPREND = 1
          IF ( ICODPRO.EQ.25 ) THEN
            I_NB_CRC_P    = I_NB_CRC_P + 1
          ELSE IF ( ICODPRO.EQ.34 ) THEN
            I_NB_JAP_P    = I_NB_JAP_P + 1
          ELSE IF ( ICODPRO.EQ.52 ) THEN
            I_NB_USA_P    = I_NB_USA_P + 1
          ELSE IF ( ICODPRO.EQ.65 ) THEN
            I_NB_AUS_P    = I_NB_AUS_P + 1
          ELSE IF ( ICODPRO.EQ.71 ) THEN
            I_NB_FID_P    = I_NB_FID_P + 1
          ELSE
            ILPREND       = 0
          ENDIF
          IF ( ILPREND.EQ.1 ) THEN

           write(wagon,fmt=wagon_prov) INBP
	   fmt_final = trim(adjustl(entete))//trim(adjustl(wagon))//")"

          WRITE (NULOBI,fmt_final) CLINDIC,CLINDICAB,ICODPRO,IDAT,IETM,
     &                             CLLAT,CLLON,ISTD,
     &                             (ZPOB(J),J=1,INBP)
            KNBMECR = KNBMECR + 1
!            KNBWAG  = KNBWAG + INBP

            IF ( L_GEOPOINTS ) THEN
              ITPM = MOD( IOCH , 1000 )
              WRITE (NULGEO,'(F11.5,F11.5,I5)') ZLON,ZLAT,ITPM
            ENDIF
	  ENDIF
        ENDIF

      ENDDO OBS_BCLE

!-----------------------------------------------------------------------

      WRITE (NULOUT,301) I_NB_CRC,I_NB_CRC_P,I_NB_JAP,I_NB_JAP_P,
     &                   I_NB_USA,I_NB_USA_P,I_NB_AUS,I_NB_AUS_P,
     &                   I_NB_FID,I_NB_FID_P,I_NB_AUT,I_NB_AUT_P
 301  FORMAT(/,'     Extraction des donnees PAOB REU ',/,5X,31('-'),//,
     & '   producteur      nombre de messages extraits     no',
     & 'nbre de messsages retenus',//,2X,'CRC La Reunion',14X,I6,26X,
     & I6,/,5X,'Japon',20X,I6,26X,I6,/,6X,'USA',21X,I6,26X,I6,/,4X,
     & 'Australie',17X,I6,26X,I6,/,5X,'Fidji',20X,I6,26X,I6,/,5X,
     & 'autre',20X,I6,26X,I6,/)

!-----------------------------------------------------------------------

      RETURN
      END
