      SUBROUTINE EXT_SATGEO(KNBMESS,KNBMECR,CDTYPM,KNBWAG,
     &                     PLATN,PLATS,PLONO,PLONE,KPLEIN)
!-----------------------------------------------------------------------
!  auteur de revision : F. Guillaume
!  date de revision   : 17/03/2008
!  objet              : formats explicites d'ecriture dans OBSOUL
!                       pour mise en conofmite SOPRANO.
!=======================================================================
      IMPLICIT LOGICAL(L)

#include "oulan_pardimo.h"
#include "oulan_yomtomv.h"
#include "oulan_yompin.h"
#include "oulan_yomdirs.h"
#include "oulan_yomnbob.h"
#include "oulan_yomdate.h"
#include "oulan_yomcsts.h"

      PARAMETER ( JP_NBX_PAR = 3      )

      CHARACTER  CLLAT            *  12 , CLLON                   *   12
      CHARACTER  CDTYPM           *  10 , CL_NULL                 *    5

      CHARACTER  CL_TYPE_MESS     *  20 , CL_VERS_MESS            *   20
      CHARACTER  CL_MIN_DATE      *  14 , CL_MAX_DATE             *   14
      CHARACTER  CL_LAST_ARRIVED  *   1 , CL_DONNEES(5,KNBMESS)   *   80
      CHARACTER  CL_FROM          * 127 , CL_ORDER                *  127
      CHARACTER  CL_BASE          *   1 , CL_WHERE                * 1023
      CHARACTER  CL_AUTORISATION  *  30
      INTEGER    I_PAS_DE_TPS , I_NB_PARAM , I_TYPE_SORTIE , I_NBRE_STAT
      INTEGER    I_CQ_BDM(30,KNBMESS),I_CODE_RETOUR_EXT , I_NB_MESS
      REAL       Z_DONNEES(30,KNBMESS)

      REAL  DL_MIN_LAT , DL_MAX_LAT
      REAL  DL_MIN_LON , DL_MAX_LON

      CHARACTER  CLINDIC*12,CLSAT(30)*12,CLSATOUT(10)*3,CLNBSATOUT(10)*6
      INTEGER    IVNM(JP_NBX_PAR),IFLG(JP_NBX_PAR),INCQ(0:3)
      INTEGER    INBMSB(30),ISTNUM(30),INBSATOUT(10)
      REAL       ZPOB(JP_NBX_PAR),ZPRL(JP_NBX_PAR),ZVAR(JP_NBX_PAR)


! ----------------------------------------------------------------------
! code pour realiser des sorties formatees  OBSOUL (SOPRANO)

      character entete * 84, wagon_prov * 34
      character wagon  * 34, fmt_final * 117
! ----------------------------------------------------------------------


#include "oulan_yombitu.h"

! ----------------------------------------------------------------------
! code pour realiser des sorties formatees  OBSOUL (SOPRANO)

      entete = "(I4,1X,I2,1X,I9,1X,F9.5,1X,F10.5,1X,A12,1X,I8,1X,I6,1X"
      entete = trim(adjustl(entete)) // ",ES12.5,1X,I5,1X,I7,1X,I7,1X,"
      wagon_prov = "(I5,'(1X,I3,1X,3(ES12.5,1X),I11)')"                       
! ----------------------------------------------------------------------

      KNBMECR = 0
      KPLEIN  = 0

      DO J=1,127
        CL_FROM(J:J)  = ' '
        CL_ORDER(J:J) = ' '
      ENDDO

      DO J=1,1023
        CL_WHERE(J:J)  = ' '
      ENDDO

      CL_NULL      = 'NULL'//CHAR(0)
      CLSAT        = '            '
      INBMSB       = 0
      ISTNUM       = 0
      INCQ(0)      = 0
      INCQ(1)      = 2
      INCQ(2)      = 3
      INCQ(3)      = 1
      IZERO        = 0
      ICQUN        = 1
      INUMST       = 0
      CLNBSATOUT   = '      '
      CLSATOUT     = '   '
      INBSATOUT    = 0
      I_NB_SAT_OUT = 0

!-----------------------------------------------------------------------

!  Initialisations des arguments de la fonction d'extraction
!  ---------------------------------------------------------

      CL_TYPE_MESS        = CDTYPM(1:6)//CHAR(0)
      CL_VERS_MESS        = '%'
      CL_MIN_DATE         = CDATDEB(2)
      CL_MAX_DATE         = CDATFIN(2)
      CL_AUTORISATION     = 'OPER'
      CL_LAST_ARRIVED     = 'Y'
      CL_BASE             = 'Y'
      CL_WHERE            = ' and dd is not null'

      I_PAS_DE_TPS        = 0
      I_NB_PARAM          = 0
      I_TYPE_SORTIE       = 3
      I_NBRE_STAT         = 0
      I_NB_MESS           = KNBMESS

      DL_MIN_LAT          = PLATS
      DL_MAX_LAT          = PLATN
      DL_MIN_LON          = PLONO
      DL_MAX_LON          = PLONE

      CL_DONNEES          = ' '
      Z_DONNEES           = RABSI
      I_CQ_BDM            = NABSI

!-----------------------------------------------------------------------

!  Extraction
!  ----------

      PRINT *,' '
      PRINT *,' Extraction des ',CDTYPM
      PRINT *,' '

      CALL RDLLTDOMCLAUSE( CL_TYPE_MESS , CL_VERS_MESS , CL_MIN_DATE ,
     &                     CL_MAX_DATE , CL_AUTORISATION ,
     &                     CL_LAST_ARRIVED , I_PAS_DE_TPS ,
     &                     CL_NULL , I_NB_PARAM , Z_DONNEES ,
     &                     CL_DONNEES , CL_NULL , I_TYPE_SORTIE ,
     &                     I_NB_MESS , DL_MIN_LAT , DL_MAX_LAT ,
     &                     DL_MIN_LON , DL_MAX_LON , CL_NULL ,
     &                     I_NBRE_STAT , CL_FROM , CL_WHERE ,
     &                     CL_ORDER , CL_BASE , I_CODE_RETOUR_EXT )

      PRINT *,' '
      PRINT *,' Fin de l''extraction '
      PRINT *,' '


      IF ( I_CODE_RETOUR_EXT.NE.0 .AND. I_CODE_RETOUR_EXT.NE.1 ) THEN
        PRINT 101,CDTYPM,I_CODE_RETOUR_EXT
 101    FORMAT(/,' Probleme lors de l''extraction des ',A10,
     &             ' I_CODE_RETOUR_EXT = ',I2,/)
        RETURN
      ENDIF

      IF ( I_NB_MESS.EQ.KNBMESS ) KPLEIN = I_NB_MESS
      IF ( NINIT.EQ.1 ) RETURN

!-----------------------------------------------------------------------

!  Traitements
!  -----------

      OBS_BCLE: DO JO=1,I_NB_MESS
        IF ( Z_DONNEES(16,JO).EQ.RABSI .OR.
     &       I_CQ_BDM(16,JO).EQ.2            ) CYCLE OBS_BCLE
        IF ( LCUTOFF .AND. 
     &       CL_DONNEES(1,JO)(1:14).GT.CDATFIN(4) ) CYCLE OBS_BCLE
        IRLN    = NABSO
        IOTP    = NABSO
        IOCH    = NABSO
        ZLAT    = RABSO
        ZLON    = RABSO
        IDAT    = NABSO
        IETM    = NABSO
        ZALT    = RABSO
        INLV    = NABSO
        IRFL    = 11111
        ISTD    = 0
        CLINDIC = " '        ' "
        CLLAT   = '            '
        CLLON   = '            '
        ICQLAT  = 1
        ICQLON  = 1
        ICQDAT  = 1
        ICQETM  = 1
        ICQALT  = 1

        DO JA=1,JP_NBX_PAR
          IVNM(JA) = NABSO
          ZPOB(JA) = RABSO
          ZPRL(JA) = RABSO
          ZVAR(JA) = RABSO
          IFLG(JA) = NABSO
        ENDDO

!  Saisie de la locomotive

        IOTP = NSATOB
        ZLAT = Z_DONNEES(12,JO)
        ZLON = Z_DONNEES(13,JO)
        IF ( I_CQ_BDM(12,JO).EQ.2 .OR. I_CQ_BDM(13,JO).EQ.2 ) 
     &    CYCLE OBS_BCLE
        WRITE (CLLAT(2:11),'(F10.5)') ZLAT
        WRITE (CLLON(2:11),'(F10.5)') ZLON
        IOCH    = 0
        IMETMES = 0
        INOSAT  = 69

!   methode de mesure des vents
!  -----------------------------

!   1 vents derives du deplacement des nuages dans le canal infra-rouge
!   2 vents derives du deplacement des nuages dans le canal visible
!   3 vents derives des mouvements des nuages dans le canal vapeur d'eau
!   4 vents derives des mouvements des nuages dans les canaux spectraux combines

        IF ( Z_DONNEES(14,JO).NE.RABSI )
     &    IMETMES = NINT( Z_DONNEES(14,JO) )
        IF ( IMETMES.EQ.15 ) IMETMES = 0

!   origine        --------- BDM ---------           CMAFOC
!                 I1I2I2  ->  I6I6I6 F3F3F3        OCH   SID
!  ---------------------------------------------------------------------------
!   Meteosat-5      005         052    254         254   052     Europe
!   Meteosat-7                  054    254         254   054     Europe

        IF ( Z_DONNEES(1,JO).NE.RABSI ) THEN
          INOSAT = 0
          IINDIC = NINT( Z_DONNEES(1,JO) )
          WRITE (CLINDIC(8:10),'(I3.3)') IINDIC
          ILPREND = 0
          DO JSAT=1,MNBSATSEL(N_SATGEO)
            IF ( IINDIC.EQ.MNOSATSEL(N_SATGEO,JSAT) ) ILPREND = 1
          ENDDO
          IF ( ILPREND.EQ.0 ) THEN
            ILYEST = 0
            DO JSAT=1,I_NB_SAT_OUT
              IF ( CLINDIC(8:10).EQ.CLSATOUT(JSAT) ) ILYEST = JSAT
            ENDDO
            IF ( ILYEST.EQ.0 ) THEN
              I_NB_SAT_OUT = I_NB_SAT_OUT + 1
              IF ( I_NB_SAT_OUT.LE.10 ) THEN
                CLSATOUT(I_NB_SAT_OUT)  = CLINDIC(8:10)
                INBSATOUT(I_NB_SAT_OUT) = 1
              ENDIF
            ELSE IF ( ILYEST.LE.10 ) THEN
              INBSATOUT(ILYEST) = INBSATOUT(ILYEST) + 1
            ENDIF
            CYCLE OBS_BCLE
          ENDIF
          ILENVE = 0
          DO JNST=1,INUMST
            IF ( IINDIC.EQ.ISTNUM(JNST) ) ILENVE = JNST
          ENDDO
          IF ( ILENVE.GT.0 ) THEN
            INOSAT = ILENVE
          ELSE
            INUMST = INUMST + 1
            ISTNUM(INUMST) = IINDIC
            INOSAT = INUMST
          ENDIF
          INBMSB(INOSAT) = INBMSB(INOSAT) + 1
          ICODPROD = NINT( Z_DONNEES(20,JO) )
        ELSE
          CYCLE OBS_BCLE
        ENDIF

        CALL OULAN_CAROBS(IOTP,CDTYPM,ICODPROD,IMETMES,IZERO,ZLAT,IOCH)

        IDAT = NINT( Z_DONNEES( 7,JO) ) * 10000  +
     &         NINT( Z_DONNEES( 8,JO) ) * 100    +
     &         NINT( Z_DONNEES( 9,JO) )
        IETM = NINT( Z_DONNEES(10,JO) ) * 10000  +
     &         NINT( Z_DONNEES(11,JO) ) * 100

        IF ( I_CQ_BDM(12,JO).NE.NABSI ) ICQLAT = INCQ(I_CQ_BDM(12,JO))
        IF ( I_CQ_BDM(13,JO).NE.NABSI ) ICQLON = INCQ(I_CQ_BDM(13,JO))
        IF ( I_CQ_BDM( 7,JO).NE.NABSI .AND. I_CQ_BDM( 8,JO).NE.NABSI
     &       .AND. I_CQ_BDM( 9,JO).NE.NABSI )
     &    ICQDAT = MAX0( INCQ(I_CQ_BDM( 7,JO)) ,
     &                   MAX0( INCQ(I_CQ_BDM( 8,JO)) ,
     &                         INCQ(I_CQ_BDM( 9,JO)) ) )
        IF ( I_CQ_BDM(10,JO).NE.NABSI .AND. I_CQ_BDM(11,JO).NE.NABSI )
     &    ICQETM = MAX0(INCQ(I_CQ_BDM(10,JO)),INCQ(I_CQ_BDM(11,JO)))
        IRFL = ICQALT*10000 + ICQETM*1000 + ICQDAT*100 + ICQLON*10 +
     &         ICQLAT

        IF ( Z_DONNEES(5,JO).NE.RABSI )
     &    ISTD = INT(Z_DONNEES(5,JO)+REPSILON)

!  Saisie des wagons

!  composition du code qualite (IFLG) :

!     bits 1 et 2   code qualite coordonnee verticale
!     bits 3 et 4   code qualite parametre mesure
!     bit    12     coordonnee verticale en Pascals

        ZPRESS = Z_DONNEES(16,JO)
        ICQCV  = 3
        ICQPAT = 3
        ICQPAV = 3
        IF ( I_CQ_BDM(16,JO).NE.NABSI ) ICQCV  = I_CQ_BDM(16,JO)
        IF ( I_CQ_BDM(17,JO).NE.NABSI ) ICQPAT = I_CQ_BDM(17,JO)
        IF ( I_CQ_BDM(18,JO).NE.NABSI ) ICQPAV = I_CQ_BDM(18,JO)
        INBP = 0

!  temperature

        IF ( Z_DONNEES(17,JO).NE.RABSI .AND.
     &       I_CQ_BDM(17,JO).NE.2             ) THEN
          INBP = INBP + 1
          IVNM(INBP) = NVNUMB(8)
          ZPOB(INBP) = ZPRESS
          ZVAR(INBP) = Z_DONNEES(17,JO)
          IFLG(INBP) = 0
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV,1)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQPAT,3)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
        ENDIF

!  direction et force du vent

        IF ( Z_DONNEES(18,JO).NE.RABSI .AND.
     &       Z_DONNEES(19,JO).NE.RABSI .AND.
     &       Z_DONNEES(18,JO).NE.400.  .AND.
     &       I_CQ_BDM(18,JO).NE.2      .AND.
     &       I_CQ_BDM(19,JO).NE.2             ) THEN
          INBP = INBP + 1
          IVNM(INBP) = NVNUMB(1)
          ZPOB(INBP) = ZPRESS
          ZPRL(INBP) = Z_DONNEES(19,JO)
          ZVAR(INBP) = Z_DONNEES(18,JO)
          IFLG(INBP) = 0
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV,1)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQPAV,3)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
          IFLG(INBP) = ICQPAV*10 + ICQCV
        ENDIF

        INLV = INBP
        IRLN = NCILET + INLV*NCILBO

!  Copie de l'observation sur le fichier d'obs.

        IF ( INBP.GT.0 ) THEN

           write(wagon,fmt=wagon_prov) INBP
	   fmt_final = trim(adjustl(entete))//trim(adjustl(wagon))//")"

          WRITE (NULOBI,fmt_final) IRLN,IOTP,IOCH,ZLAT,ZLON,CLINDIC,
     &                     IDAT,IETM,ZALT,INLV,IRFL,ISTD,
     &                     (IVNM(J),ZPOB(J),ZPRL(J),ZVAR(J),
     &                     IFLG(J),J=1,INBP)
          KNBMECR = KNBMECR + 1
          KNBWAG  = KNBWAG + INBP
          IF ( L_GEOPOINTS ) 
     &      WRITE (NULGEO,'(F11.5,F11.5,I5)') ZLON,ZLAT,IINDIC
        ENDIF

      ENDDO OBS_BCLE

!-----------------------------------------------------------------------

!  Impressions
!  -----------

      ITOT = 0
      DO J=1,30
        ITOT = ITOT + INBMSB(J)
      ENDDO

      IF ( ITOT.GT.0 ) THEN
        WRITE (NULOUT,301)
        DO J=1,30
          IF ( INBMSB(J).GT.0 )  WRITE (NULOUT,302) ISTNUM(J),INBMSB(J)
        ENDDO
        WRITE (NULOUT,303)
      ENDIF
      DO J=1,10
        IF ( INBSATOUT(J).GT.0 )
     &    WRITE (CLNBSATOUT(J),'(I6)') INBSATOUT(J)
      ENDDO
      IF ( I_NB_SAT_OUT.GT.0 ) WRITE (NULOUT,304) CLSATOUT,CLNBSATOUT

 301  FORMAT(/,4X,' Extraction des messages SATGEO ',/,5X,30('-'),/)
 302  FORMAT(2X,'satellite ',I3.3,5X,I5)
 303  FORMAT(//)
 304  FORMAT(/,' Satellites extraits, non retenus : ',10(3X,A3,2X),/,
     &       36X,10(A6,2X))

!-----------------------------------------------------------------------

      RETURN
      END
