      SUBROUTINE EXT_TOVSMSU(KNBMESS,KNBMECR,CDTYPM,KNBWAG,
     &                       PLATN,PLATS,PLONO,PLONE,KPLEIN)
!-----------------------------------------------------------------------
!  auteur de revision : F. Guillaume
!  date de revision   : 17/03/2008
!  objet              : formats explicites d'ecriture dans OBSOUL
!                       pour mise en conofmite SOPRANO.
!=======================================================================
      IMPLICIT LOGICAL(L)

#include "oulan_pardimo.h"
#include "oulan_yomtomv.h"
#include "oulan_yompin.h"
#include "oulan_yomdirs.h"
#include "oulan_yomnbob.h"
#include "oulan_yomdate.h"
#include "oulan_yomcsts.h"

      PARAMETER ( JP_NBX_PAR = 20      , JP_DIM_STRUCT = 170          )

      CHARACTER  CLLAT            * 12 , CLLON                     * 12
      CHARACTER  CDTYPM           * 10 , CL_NULL                 *    5

      CHARACTER  CL_TYPE_MESS     * 20 , CL_VERS_MESS              * 20
      CHARACTER  CL_MIN_DATE      * 14 , CL_MAX_DATE               * 14
      CHARACTER  CL_LAST_ARRIVED  *  1 , CL_LISTE_PARAM(1)         * 15
      CHARACTER  CL_LISTE_STAT(1) *  4 , CL_DONNEES(5,KNBMESS)     * 80
      CHARACTER  CL_AUTORISATION  * 30
      INTEGER    I_PAS_DE_TPS , I_NB_PARAM , I_TYPE_SORTIE , I_NBRE_STAT
      INTEGER    I_CQ_BDM(JP_DIM_STRUCT,KNBMESS)
      INTEGER    I_CODE_RETOUR_EXT , I_NB_MESS
      REAL       Z_DONNEES(JP_DIM_STRUCT,KNBMESS)

      REAL  DL_MIN_LAT , DL_MAX_LAT
      REAL  DL_MIN_LON , DL_MAX_LON

      CHARACTER CLINDIC*12,CLSATOUT(10)*3,CLNBSATOUT(10)*6
      INTEGER   ICODM(KNBMESS),IVNM(JP_NBX_PAR),IFLG(JP_NBX_PAR)
      INTEGER   INCQ(0:3),ICODL(0:3),ICODC(0:18),INBSATOUT(10)
      REAL      ZPOB(JP_NBX_PAR),ZPRL(JP_NBX_PAR),ZVAR(JP_NBX_PAR)

! ----------------------------------------------------------------------
! code pour realiser des sorties formatees  OBSOUL (SOPRANO)

      character entete * 84, wagon_prov * 34
      character wagon  * 34, fmt_final * 117
! ----------------------------------------------------------------------


#include "oulan_yombitu.h"

! ----------------------------------------------------------------------
! code pour realiser des sorties formatees  OBSOUL (SOPRANO)

      entete = "(I4,1X,I2,1X,I9,1X,F9.5,1X,F10.5,1X,A12,1X,I8,1X,I6,1X"
      entete = trim(adjustl(entete)) // ",ES12.5,1X,I5,1X,I7,1X,I7,1X,"
      wagon_prov = "(I5,'(1X,I3,1X,3(ES12.5,1X),I11)')"                       
! ----------------------------------------------------------------------
      CL_NULL  = 'NULL'//CHAR(0)

      INCQ(0) = 0
      INCQ(1) = 2
      INCQ(2) = 3
      INCQ(3) = 1

      ICODL(0) = 0
      ICODL(1) = 1
      ICODL(2) = 0
      ICODL(3) = 0

      ICODC( 0) = 1
      ICODC( 1) = 0
      ICODC( 2) = 0
      ICODC( 3) = 1
      ICODC( 4) = 0
      ICODC( 5) = 0
      ICODC( 6) = 0
      ICODC( 7) = 1
      ICODC( 8) = 0
      ICODC( 9) = 0
      ICODC(10) = 0
      ICODC(11) = 1
      ICODC(12) = 0
      ICODC(13) = 0
      ICODC(14) = 0
      ICODC(15) = 1
      ICODC(16) = 0
      ICODC(17) = 0
      ICODC(18) = 0

      IZERO     = 0
      ICQUN     = 1

      DO J=1,10
        CLNBSATOUT(J) = '      '
        CLSATOUT(J)   = '   '
        INBSATOUT(J)  = 0
      ENDDO

      I_NB_SAT_OUT = 0

!-----------------------------------------------------------------------

!  Initialisations des arguments de la fonction d'extraction
!  ---------------------------------------------------------

      CL_TYPE_MESS( 1:10) = CDTYPM
      CL_TYPE_MESS(11:20) = '          '
      CL_VERS_MESS        = '%                   '
      CL_MIN_DATE         = CDATDEB(2)
      CL_MAX_DATE         = CDATFIN(2)
      CL_AUTORISATION     = 'OPER                          '
      CL_LAST_ARRIVED     = 'Y'
      CL_LISTE_STAT(1)    = 'NULL'
      CL_LISTE_PARAM(1)   = 'NULL           '

      I_PAS_DE_TPS        = 0
      I_NB_PARAM          = 0
      I_TYPE_SORTIE       = 3
      I_NBRE_STAT         = 0
      I_NB_MESS           = KNBMESS

      DL_MIN_LAT          = PLATS
      DL_MAX_LAT          = PLATN
      DL_MIN_LON          = PLONO
      DL_MAX_LON          = PLONE

      CL_DONNEES          = ' '
      Z_DONNEES           = RABSI
      I_CQ_BDM            = NABSI

      KNBMECR = 0
      KPLEIN  = 0

!-----------------------------------------------------------------------

!  Extraction
!  ----------

      PRINT *,' '
      PRINT *,' Extraction des ',CDTYPM
      PRINT *,' '

      CALL RDLLTDOMAINDECOD( CL_TYPE_MESS , CL_VERS_MESS , CL_MIN_DATE ,
     &                       CL_MAX_DATE , CL_AUTORISATION ,
     &                       CL_LAST_ARRIVED , I_PAS_DE_TPS ,
     &                       CL_NULL , I_NB_PARAM , Z_DONNEES ,
     &                       CL_DONNEES , CL_NULL , I_TYPE_SORTIE ,
     &                       I_NB_MESS , DL_MIN_LAT , DL_MAX_LAT ,
     &                       DL_MIN_LON , DL_MAX_LON , CL_NULL ,
     &                       I_NBRE_STAT , I_CODE_RETOUR_EXT )

      PRINT *,' '
      PRINT *,' Fin de l''extraction '
      PRINT *,' '
      PRINT *,' I_NB_MESS ',i_nb_mess

      IF ( I_CODE_RETOUR_EXT.NE.0 .AND.
     &     I_CODE_RETOUR_EXT.NE.1       ) THEN
        PRINT 101,CDTYPM,I_CODE_RETOUR_EXT
 101    FORMAT(/,' Probleme lors de l''extraction des ',A10,
     &         ' I_CODE_RETOUR_EXT = ',I2,/)
        RETURN
      ENDIF

      IF ( I_NB_MESS.EQ.KNBMESS ) KPLEIN = I_NB_MESS
      IF ( NINIT.EQ.1 ) RETURN

!-----------------------------------------------------------------------

!  Traitements
!  -----------

! 170 valeurs pour 1 message

      BOUCLE_MESSAGE: DO JO=1,I_NB_MESS
        IF ( LCUTOFF .AND. 
     &       CL_DONNEES(1,JO)(1:14).GT.CDATFIN(4) ) CYCLE BOUCLE_MESSAGE
        IRLN      = NABSO
        IOTP      = NABSO
        IOCH      = NABSO
        ZLAT      = RABSO
        ZLON      = RABSO
        IDAT      = NABSO
        IETM      = NABSO
        ZALT      = RABSO
        INLV      = NABSO
        IRFL      = 11111
        ISTD      = 0
        CLINDIC   = " '        ' "
        CLLAT     = '            '
        CLLON     = '            '
        ICQLAT    = 1
        ICQLON    = 1
        ICQDAT    = 1
        ICQETM    = 1
        ICQALT    = 1

        DO JA=1,JP_NBX_PAR
          IVNM(JA) = NABSO
          ZPOB(JA) = RABSO
          ZPRL(JA) = RABSO
          ZVAR(JA) = RABSO
          IFLG(JA) = NABSO
        ENDDO

!  Saisie de la locomotive

        I_NB_MES_PAQ = NINT(Z_DONNEES(162,JO))

        IOTP = NSATEM
        ZLAT = Z_DONNEES(27,JO)
        ZLON = Z_DONNEES(28,JO)
        IF ( I_CQ_BDM(27,JO).EQ.2 .OR.
     &       I_CQ_BDM(28,JO).EQ.2 ) CYCLE BOUCLE_MESSAGE
        WRITE (CLLAT(2:11),'(F10.5)') ZLAT
        WRITE (CLLON(2:11),'(F10.5)') ZLON

        CALL OULAN_CAROBS(IOTP,CDTYPM,IZERO,IZERO,IZERO,ZLAT,IOCH)

        IDAT = NINT( Z_DONNEES(21,JO) ) * 10000  +
     &         NINT( Z_DONNEES(22,JO) ) * 100    +
     &         NINT( Z_DONNEES(23,JO) )
        IETM = NINT( Z_DONNEES(24,JO) ) * 10000  +
     &         NINT( Z_DONNEES(25,JO) ) * 100    +
     &         FLOOR( Z_DONNEES(26,JO) )

        IF ( Z_DONNEES(12,JO).NE.RABSI ) THEN
          IINDIC = NINT( Z_DONNEES(12,JO) )
          WRITE (CLINDIC(8:10),'(I3.3)') IINDIC
          ILPREND = 0
          DO JSAT=1,MNBSATSEL(N_TOVSMSU)
            IF ( IINDIC.EQ.MNOSATSEL(N_TOVSMSU,JSAT) ) ILPREND = 1
          ENDDO
          IF ( ILPREND.EQ.0 ) THEN
            ILYEST = 0
            DO JSAT=1,I_NB_SAT_OUT
              IF ( CLINDIC(8:10).EQ.CLSATOUT(JSAT) ) ILYEST = JSAT
            ENDDO
            IF ( ILYEST.EQ.0 ) THEN
              I_NB_SAT_OUT = I_NB_SAT_OUT + 1
              IF ( I_NB_SAT_OUT.LE.10 ) THEN
                CLSATOUT(I_NB_SAT_OUT)  = CLINDIC(8:10)
                INBSATOUT(I_NB_SAT_OUT) = 1
              ENDIF
            ELSE IF ( ILYEST.LE.10 ) THEN
              INBSATOUT(ILYEST) = INBSATOUT(ILYEST) + 1
            ENDIF
            CYCLE BOUCLE_MESSAGE
          ENDIF
        ELSE
          CYCLE BOUCLE_MESSAGE
        ENDIF

        IF ( I_CQ_BDM(27,JO).NE.NABSI )
     &    ICQLAT = INCQ(I_CQ_BDM(27,JO))
        IF ( I_CQ_BDM(28,JO).NE.NABSI )
     &    ICQLON = INCQ(I_CQ_BDM(28,JO))
        IF ( I_CQ_BDM(21,JO).NE.NABSI .AND.
     &       I_CQ_BDM(22,JO).NE.NABSI .AND.
     &       I_CQ_BDM(23,JO).NE.NABSI )
     &    ICQDAT = MAX0( INCQ(I_CQ_BDM(21,JO)) ,
     &                   MAX0( INCQ(I_CQ_BDM(22,JO)) ,
     &                         INCQ(I_CQ_BDM(23,JO)) ) )
        IF ( I_CQ_BDM(24,JO).NE.NABSI .AND.
     &       I_CQ_BDM(25,JO).NE.NABSI .AND.
     &       I_CQ_BDM(26,JO).NE.NABSI )
     &    ICQETM = MAX0( INCQ(I_CQ_BDM(24,JO)) ,
     &                   MAX0( INCQ(I_CQ_BDM(25,JO)) ,
     &                         INCQ(I_CQ_BDM(26,JO)) ) )
        IRFL = ICQALT*10000 + ICQETM*1000 + ICQDAT*100 + ICQLON*10 +
     &         ICQLAT

        IF ( Z_DONNEES(10,JO).NE.RABSI )
     &    ISTD = INT(Z_DONNEES(10,JO)+REPSILON)


!  informations auxiliaires

! info 1  NCMSSIA, NCMSCLA, NCMFOVA

        IVNM(1) = NVNUMB(59)
        IF ( Z_DONNEES(13,JO).NE.RABSI ) 
     &    ZPOB(1) = Z_DONNEES(13,JO)  
        IF ( Z_DONNEES(16,JO).NE.RABSI )
     &    ZPRL(1) = Z_DONNEES(16,JO)
        IF ( Z_DONNEES(17,JO).NE.RABSI )
     &    ZVAR(1) = Z_DONNEES(17,JO)

! info 2  NCMSTHA, NCMSAZA, NCMSABA

        IVNM(2) = NVNUMB(59)
        IF ( Z_DONNEES(29,JO).NE.RABSI )
     &    ZPOB(2) = Z_DONNEES(29,JO)
        IF ( Z_DONNEES(30,JO).NE.RABSI )
     &    ZPRL(2) = Z_DONNEES(30,JO)
        IF ( Z_DONNEES(31,JO).NE.RABSI )
     &    ZVAR(2) = Z_DONNEES(31,JO)

! info 3  NCMSOZA, NCMSOBA

        IVNM(3) = NVNUMB(59)
        IF ( Z_DONNEES(32,JO).NE.RABSI )
     &    ZPOB(3) = Z_DONNEES(32,JO)
        IF ( Z_DONNEES(33,JO).NE.RABSI )
     &    ZPRL(3) = Z_DONNEES(33,JO)

        INBP = 3

!  Saisie des wagons

!  composition du code qualite (IFLG) :

!     bits 1 et 2   code qualite coordonnee verticale
!     bits 3 et 4   code qualite parametre mesure
!     bit    16     coordonnee verticale : numero de canal

        ICQCV = 3
        ICQPA = 3
        DO JTB=1,4
          IF ( .NOT.LTMSUTB(JTB) ) CYCLE
          ID = 42 + (JTB-1)*6
          IF ( Z_DONNEES(ID+6,JO).NE.RABSI ) THEN
            INBP = INBP + 1
            IVNM(INBP) = NVNUMB(50)
            ZPOB(INBP) = Z_DONNEES(ID+1,JO)
            ZPRL(INBP) = RABSO
            ZVAR(INBP) = Z_DONNEES(ID+6,JO)
            ICQPA      = 3
            IF ( I_CQ_BDM(ID+6,JO).NE.NABSI )
     &        ICQPA = I_CQ_BDM(ID+6,JO)
            IFLG(INBP) = 0
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV,1)
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA,3)
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,16)
          ENDIF
        ENDDO
        INLV = INBP
        IRLN = NCILET + INLV*NCILBO

!  Copie de l'observation sur le fichier d'obs.

        IF ( INBP.GT.3 ) THEN

          write(wagon,fmt=wagon_prov) INBP
	  fmt_final = trim(adjustl(entete))//trim(adjustl(wagon))//")"

          WRITE (NULOBI,fmt_final) IRLN,IOTP,IOCH,ZLAT,ZLON,CLINDIC,
     &                     IDAT,IETM,ZALT,INLV,IRFL,ISTD,
     &                     (IVNM(J),ZPOB(J),ZPRL(J),ZVAR(J),
     &                     IFLG(J),J=1,INBP)
          KNBMECR = KNBMECR + 1
          KNBWAG  = KNBWAG + INBP
          IF ( L_GEOPOINTS ) 
     &      WRITE (NULGEO,'(F11.5,F11.5,I5)') ZLON,ZLAT,IINDIC
        ENDIF

      ENDDO BOUCLE_MESSAGE

!-----------------------------------------------------------------------

      DO J=1,10
        IF ( INBSATOUT(J).GT.0 )
     &    WRITE (CLNBSATOUT(J),'(I6)') INBSATOUT(J)
      ENDDO
      IF ( I_NB_SAT_OUT.GT.0 ) WRITE (NULOUT,201) CLSATOUT,CLNBSATOUT
 201  FORMAT(/,' Satellites extraits, non retenus : ',10(3X,A3,2X),/,
     &       36X,10(A6,2X))

!-----------------------------------------------------------------------

      RETURN
      END
